'use strict';
module.exports = async (arg) => {
    const fs = require('fs');
    const paths = require('path');
    const logs = require('../utils/logs');
    const progress = require('../utils/progress');
    const {isUrl} = require('../utils/utils');
    const { isDir, isFile, addDir, dirFile, delFile, copyFile,getSize } = require('../utils/fs');
    function copys(url) {
        return new Promise(async (resolve) => {
            const dir = paths.dirname(url);
            if (isUrl(url)) {
                // 下载文件
                let size = 0;
                const download = require('../plug-in/download');
                let path = paths.basename(url.split('?')[0]);
                path = paths.join(process.cwd(), path);
                const bar = new progress(100, 'Copy Successful ');
                let max = await download({
                    url,
                    path,
                    size(d){
                        size = d;
                        if(max==0) bar.end = size;
                        bar.add(size);
                    },
                    err(){
                        logs.r('Resource Error !!!');
                    }
                })
                bar.end = max;
            } else if (isDir(url)) {
                // 复制文件夹
                let size = 0;
                const list = dirFile(url);
                const max = getSize(list);
                const bar = new progress(max, 'Copy Successful ');
                bar.add();
                for (const key in list) {
                    const dirs = key.replace(dir, process.cwd() + '\\')
                    if (list[key] == 'dir') {
                        // 创建目录
                        if (!isDir(dirs)) await addDir(dirs);
                    } else {
                        // 创建文件
                        if (isFile(dirs)) await delFile(dirs);// 删除文件
                        await copyFile(key,dirs,(e)=>{
                            size += e;
                            bar.add(size);
                        });// 复制文件
                    }
                    
                }
                bar.add(max);
                resolve(true);
            } else if (isFile(url)) {
                // 复制文件
                let bytes = 0;
                const size = fs.statSync(url).size; // 获取源文件大小
                const bar = new progress(size, 'Copy Successful ');
                const dirs = url.replace(dir, process.cwd() + '');
                await copyFile(url,dirs,(e)=>{
                    bytes += e;
                    bar.add(bytes);
                })
            } else {
                // 下载文件
                logs.r('Resource Error !!!','10202');
                resolve(true);
            }
        })
    }
    let add = [];
    for (let i = 0; i < arg.length; i++) {
        if (!add.includes(arg[i])) {
            add.push(arg[i]);
            console.log('\n');
            console.log('Resources From ' + arg[i] + '\n');
            await copys(arg[i]);
        } else {
            console.log('\n');
            logs.y('Resources Duplicate ' + arg[i]);
        }
        if (i == arg.length - 1) console.log('\n');
    };
}