'use strict';
module.exports = async(arg)=>{
    const logs = require('../utils/logs');
    const path = require('../utils/path');
    const {isDir,isFile,addDir,addFile} = require('../utils/fs');
    if(!isDir(path.fk2)) await addDir(path.fk2);
    if(arg.length!==1) {
        logs.r('Config param error');
        logs.g('fk2 init [serverDir]');
    }else{
        if(!isDir(arg[0])){
            logs.r('Dir does not exist');
            logs.g('fk2 init [serverDir]');
        }else{
            if(!isFile(path.conf)) {
                const {key,ekey} = require('rrid');
                const obj = {
                    dir:arg[0],
                    safeKey:key(36),
                    createTime:new Date().getTime()
                };
                const res = await addFile(path.conf,ekey(JSON.stringify(obj)));
                if(res){
                    logs.g('Initialized successfully');
                }else{
                    logs.g('initialization failed');
                }
            }else{
                logs.r('Already initialized');
            }
        }
    }
}