'use strict';
module.exports = async (arg) => {
    const init = require('../utils/init');
    const open = require('../service/open');
    const logs = require('../utils/logs');
    const {isDir,readJson} = require('../utils/fs');
    if(arg.length==0){
        const path = require('../utils/path');
        // 检查初始目录是否存在
        if(!isDir(path.fk2)){
            await init();
            logs.r('Not yet configured');
        }else{
            // 检查配置文件
            const data = await readJson(path.conf);
            const {decrypt} = require('../utils/crypto')();
            if(data){
                // 开启服务
                await open([JSON.parse(decrypt(data))]);
            }else{
                logs.r('Not yet configured');
                logs.g('fk2 server hostName:port serverDir');
            }
        }
    }else if(arg.length==2){
        await init();
        const arr = arg[0].split(':');
        if(arr.length!==2){
            logs.r('Config param error');
            logs.g('fk2 server hostName:port serverDir');
            return;
        }       
        // 检查目录是否存在
        if(!isDir(arg[1])){
            // 不存在
            logs.r('The serverDir directory does not exist');
            logs.g('fk2 server hostName:port serverDir');
        }else{
            // 检查端口
            const {isPort} = require('../utils/utils');
            if(!isPort(arr[1])){
                logs.r('The Port Error');
            }else{
                const res = await open([arg[1],arr[0],arr[1]]);
                if(res==true){
                    // 存server路径

                }
            }
        }
    }
}