'use strict';
module.exports = (obj)=>{
    const {delFile} = require('../utils/fs');
    return new Promise(async (resolve) => {
        try {
            let max = 0;
            let size = 0;
            const fs = require('fs');
            const axios = require('axios');
            const newStream = fs.createWriteStream(obj.path); // 创建写入对象
            const req = await axios({
                url:obj.url,
                method: "GET",
                responseType: "stream"
            });
            if(req.headers&&req.headers['content-length']) max = req.headers['content-length'];
            req.data.on('error', () => {
                if(obj.err) obj.err();
                newStream.close();
            });
            newStream.on("error",()=>{
                if(obj.err) obj.err();
            });
            req.data.on('data',(chunk)=>{
                newStream.write(chunk)
                if(obj.size) {
                    size += chunk.length;
                    obj.size(size);
                }
            })
            resolve(max);
        } catch (e) {
            await delFile(obj.path);
            if(obj.err) obj.err();
            resolve(0);
        }
        
    })
}