'use strict';
module.exports = async (arg) => {
    let data = {};
    const path = require('path');
    const logs = require('../utils/logs');
    const url = path.resolve(arg[0],'info.fk')
    const {decrypt} = require('../utils/crypto');
    const cluster = require('../service/cluster');
    const {isFile,readFile} = require('../utils/fs');
    if(arg.length==1){
        if(isFile(url)){
            data = await readFile(url);
            if(data) {
                data = JSON.parse(decrypt(data));
                port = data.port;
                if(data.ip) ip = data.ip;
                cluster(data);
            }else{
                logs.r('Unknown Error')
            }
        }else{
            logs.r('The config file does not exist');
            logs.g('fk2 server hostName:port serverDir');
            return
        }
    }else{
        if(isFile(url)){
            logs.r('The config file already exists');
            logs.g('fk2 server');
            return;
        }
        data.dir = arg[0];
        data.ip = arg[1];
        data.port = arg[2];
        cluster(data);
    }
}