const net = require('net');
const EventEmitter = require('events');
class TCPScheduler extends EventEmitter {
    constructor(ops) {
        super(ops);
        this.server = net.createServer(socket => {
            this.emit('connection', socket);
            socket.on('data', data => {
                this.emit('data', socket, data);
            });
            socket.on('end', () => {
                this.emit('end', socket);
            });
            socket.on('error', err => {
                this.emit('error', socket, err);
            });
        });
    }
    listen(...arg) {
        this.server.listen(arg);
    }
    close(cb) {
        this.server.close(cb);
    }
}
module.exports = TCPScheduler;